蓝桥杯DFS-最大数字

解题思路

我们从最高位开始要利用自己的1号操作和2号操作保证当前这个数位的数一定要尽可能最大。

然后分别考虑两种操作,首先两种操作不可能混用,因为它们是抵消的效果,所以要么对这个数全使用1操作,要么2操作。假设某个数位的值为x,首先考虑1号操作,使用后可以让该数位变大,出于贪心考虑,我们想让它变成9,那么需要进行9-x次1号操作,当然可能此时1号操作并不足以让我们将x变成9,但我们还是使用剩余的全部的次数将其变大,所以每次考虑1号操作应该使用的操作数t应该为t=min(n,9-x),此时x将变为x+t,然后进行下一位的判断。

其次我们考虑2号操作,这个的判断比较简单,它是让某个值减小,唯一能让某个数变大的机会就是将其减到0后再减就会变成9。那么这样操作需要的次数就是x+1,如果操作次数不够,那我们宁愿不使用,因为这只会让这个数位变得更小。

在深搜dfs的过程中,参数记录遍历到第几个数位以及此时累计的和,当搜索完所有数位后,将此时的和与答案进行一个取max,最后的值则为答案。

代码及解析

复制代码
#include<bits/stdc++.h>
using namespace std;
char s[20];
long long ans;                //ans: 最大值,要用long long
int A,B;                      //A:1号操作剩余次数  B:2号操作剩余次数
void dfs(int i,long long v){     //i:当前处理到第i位,v:前面已经得到的值
    int d = s[i]-'0';         //第i位的数字
    if(s[i]){                 //如果s[i]为'\0',处理结束
        int t = min(A,9-d);   //1操作次数t:最大到9
        A -= t;               //更新A。如果A=0,也要继续dfs,目的是求值:v*10+d+t
        dfs(i+1,v*10+d+t);    //这一位最大是x+t。v*10+d+t是到这一位为止的数值
        A += t;               //恢复现场
        if(B>d){               //操作2:可以减到9
            B -= d+1;          //做d+1次,减到9
            dfs(i+1,v*10+9);
            B += d+1;          //恢复现场
        }
    }
    else   ans = max(ans,v);   //处理结束,得到这次DFS的最大值

}
int main(){
    cin >> s >> A >> B;        //数字N按字符串s读入
    dfs(0,0);                  //从N的最高位开始
    cout << ans;
    return 0;
}

对于v*10的部分,是每次都*10,即使是0,当乘3次就成了1000,大家可以手算演示一下。

相关推荐
zyl76512 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖16 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌16 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F16 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791316 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
tomwang032216 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!17 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
2501_9269783317 小时前
人机通信协议--人和机器之间的交互想象
人工智能·经验分享·算法·ai写作
行者全栈架构师17 小时前
【鸿蒙心迹】互动卡片全链路——把核心功能放到桌面(FormKit 实战)(HarmonyOS 7.x)
前端·算法·架构
无定义_17 小时前
10.11日常训练
算法